#pragma once

#include "EventManager.h"

enum fkut_JoyDirection {
	FKUT_DIR1 = 101,
	FKUT_DIR2 = 102,
	FKUT_DIR3 = 103,
	FKUT_DIR4 = 104,
	FKUT_DIR5 = 105,
	FKUT_DIR6 = 106,
	FKUT_DIR7 = 107,
	FKUT_DIR8 = 108,
	FKUT_DIR9 = 109,
};

struct CommandElem {
	int					phase, button;
	fkut_SwitchStatus	state;
};

class CommandTrigger {
private:
	unsigned long	regTime, limitTime, chargeTime;
	int				phase, index;

	vector<CommandElem>	commandArray;

public:
	CommandTrigger(void);
	virtual ~CommandTrigger(void);

	void	clearCommand(void);
	void	reset(void);

	void	setLimit(unsigned long msec);
	void	pushCommand(int phase, int button, fkut_SwitchStatus state);

	bool	check(EventManager *argEvent);
};
